#!/usr/bin/env python
#===========================================================================
#RTC Connector Module using Python
#===========================================================================
#Author:
#Written by Takayuki Sugawara, Univ of Tsukuba
#===========================================================================
#Version Information: 2007/12/10
#Ver. 1.0: Convert the ConnectorComp program(C++ Version) to Python
#===========================================================================
#Explanation about this module:
#This module provides you to control the RT Component using the python.
#===========================================================================

import sys
savepath = sys.path
sys.path.append("../../common/")

from Connector_Header import *

#-------------------------------------------------------------
def get_comp_info():
    for j in range(len(comp_lists)):
	i = 0
	Components[j] = a.GetObjectReference(comp_lists[j+1])
	Lists[j]  = a.GetPortsObject(Components[j])
	Activity[j]  = a.GetExecutionContextServices(Components[j])

	print '\n----------------------------------------'
	print 'Component[',j,'] = [',a.GetComponentProfile(Components[j]).type_name,']'
	print '----------------------------------------'
	
	print 'PortLists of the [',comp_lists[j+1],'] are as follows\n'
	for p in Lists[i]:
	    print 'NS1con_in',j+1,'[',i,'] =',p.get_port_profile().name
	    i = i+1
	    print '\n'
#-------------------------------------------------------------

#-------------------------------------------------------------
def get_comp_info2():
    for j in range(len(comp_lists2)):
	i = 0
	Components2[j] = b.GetObjectReference(comp_lists2[j+1])
	Lists2[j]  = b.GetPortsObject(Components2[j])
	Activity2[j]  = b.GetExecutionContextServices(Components2[j])

	print '\n----------------------------------------'
	print 'Component2[',j,'] = [',b.GetComponentProfile(Components2[j]).type_name,']'
	print '----------------------------------------'
	
	i = 0
	print 'PortLists of the [',comp_lists2[j+1],'] are as follows\n'
	for p in Lists2[i]:
	    print 'NS2con_in',j+1,'[',i,'] =',p.get_port_profile().name
	    i = i+1
	print '\n'
#-------------------------------------------------------------


a = RTCConnector()

# Please write your naming service
#=================================================
a.Connect2Nameservice("ufrg01.a02.aist.go.jp:2809")
#=================================================
a.GetComponentLists()

# Please write your component lists in "dic"
#=================================================
comp_lists = { 1:'MyServiceProvider0' }
#=================================================


b = RTCConnector()

# Please write your naming service
#=================================================
b.Connect2Nameservice("ufmrp02-arm.a02.aist.go.jp:2809")
#=================================================
b.GetComponentLists()

# Please write your component lists in "dic"
#=================================================
comp_lists2 = { 1:'MyServiceConsumer0' }
#=================================================


get_comp_info()
get_comp_info2()


# Please ready of the connect...
#=================================================
NS1con_in  = Lists[0]  # ports of 'MyServiceProvider0'
NS2con_in  = Lists2[0] # ports of 'MyServiceConsumer0'
time.sleep(2)


# Connnect
#=================================================
a.PortConnect(NS1con_in[0],NS2con_in[0]);
# NS1con_in[0] = ServiceProviderport of 'MyserviceProvider0'
# NS2con_in[0] = ServiceConsumerport of 'MyserviceConsumer0'


# Disconnnect
#=================================================
#a.PortDisconnect(NS1con_in[0]);


# Please ready of the activate...
#=================================================
act_in  = Activity[0]
act_out = Activity2[0]


# Activate
#=================================================
act_in[0].activate_component(Components[0])
act_out[0].activate_component(Components2[0])


# Deactivate
#=================================================
#act_in[0].deactivate_component(Components[0])
#act_out[0].deactivate_component(Components2[0])
